﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDiagramZoomPanCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }


        Rect current;
        Rect previous;
        bool MWBool = false;
        private void XamDiagram_Loaded(object sender, RoutedEventArgs e)
        {
            XamDiagram XD = sender as XamDiagram;
            current = XD.WindowRect;
            previous = XD.WindowRect;

            XD.PropertyChanged += XD_PropertyChanged;
            XD.PreviewMouseWheel += XD_PreviewMouseWheel;

        }

        void XD_PreviewMouseWheel(object sender, MouseWheelEventArgs e)
        {
            MWBool = true;
        }

        void XD_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            XamDiagram XD = sender as XamDiagram;
            if (e.PropertyName == "WindowRect")
            {
                //check X, Y, Height, Width of the Rects.
                current = XD.WindowRect;

                if (current != previous)
                {
                    if (current.Height == previous.Height && current.Width == previous.Width && (current.X != previous.X || current.Y != previous.Y))
                    {
                        Debug.Print("PANNING");
                    }
                    else if (current.Height != previous.Height && current.Width != previous.Width && (current.X != previous.X || current.Y != previous.Y) && MWBool)
                    {
                        Debug.Print("MOUSE WHEEL ZOOM");
                        MWBool = false;
                    }

                    else if (current.Height != previous.Height && current.Width != previous.Width && (current.X != previous.X || current.Y != previous.Y))
                    {
                        Debug.Print("ZOOMING");
                    }
                }

                previous = XD.WindowRect;

            }
        }
    }
}
